# This file was created automatically, do not edit!
#############################################################################
##
#W  docxpl.tst            GAP 4 package `atlasrep'              Thomas Breuer
##
#H  @(#)$Id: $
##
#Y  Copyright (C)  2001,  Lehrstuhl D fuer Mathematik,  RWTH Aachen,  Germany
##
##  This file contains the GAP code of the examples in the package
##  documentation files.
##  
##  In order to run the tests, one starts GAP from the `tst' subdirectory
##  of the `pkg/atlasrep' directory, and calls `ReadTest( "docxpl.tst" );'.
##  

gap> START_TEST("$Id: $");

# from paragraph [ 1, 5, 0, 4 ][ "./atlasrep.xml", 305 ]

gap> LoadPackage( "atlasrep" );
true

# from paragraph [ 2, 0, 0, 8 ][ "./interfac.xml", 44 ]

gap> LoadPackage( "ctbllib" );
true
gap> LoadPackage( "tomlib" );
true

# from paragraph [ 2, 4, 2, 6 ][ "./../gap/utils.gd", 188 ]

gap> AtlasClassNames( CharacterTable( "L3(4).3" ) );
[ "1A", "2A", "3A", "4ABC", "5A", "5B", "7A", "7B", "3B", "3B'", "3C", "3C'", 
  "6B", "6B'", "15A", "15A'", "15B", "15B'", "21A", "21A'", "21B", "21B'" ]
gap> AtlasClassNames( CharacterTable( "U3(5).2" ) );
[ "1A", "2A", "3A", "4A", "5A", "5B", "5CD", "6A", "7AB", "8AB", "10A", "2B", 
  "4B", "6D", "8C", "10B", "12B", "20A", "20B" ]
gap> AtlasClassNames( CharacterTable( "L2(27).6" ) );
[ "1A", "2A", "3AB", "7ABC", "13ABC", "13DEF", "14ABC", "2B", "4A", "26ABC", 
  "26DEF", "28ABC", "28DEF", "3C", "3C'", "6A", "6A'", "9AB", "9A'B'", "6B", 
  "6B'", "12A", "12A'" ]
gap> AtlasClassNames( CharacterTable( "L3(4).3.2_2" ) );
[ "1A", "2A", "3A", "4ABC", "5AB", "7A", "7B", "3B", "3C", "6B", "15A", 
  "15B", "21A", "21B", "2C", "4E", "6E", "8D", "14A", "14B" ]
gap> AtlasClassNames( CharacterTable( "3.A6" ) );
[ "1A_0", "1A_1", "1A_2", "2A_0", "2A_1", "2A_2", "3A_0", "3B_0", "4A_0", 
  "4A_1", "4A_2", "5A_0", "5A_1", "5A_2", "5B_0", "5B_1", "5B_2" ]

# from paragraph [ 2, 5, 1, 70 ][ "./../gap/interfac.gd", 288 ]

gap> DisplayAtlasInfo( [ "M11", "A5" ] );
group     #  maxes  cl  cyc  out  find  check  pres
---------------------------------------------------
M11      42      5   +    +          +      +     +
A5       18      3   -    -          -      +     +

# from paragraph [ 2, 5, 1, 75 ][ "./interfac.xml", 223 ]

gap> DisplayAtlasInfo( "A5", IsPermGroup, true );
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
1: G <= Sym(5)
2: G <= Sym(6)
3: G <= Sym(10)
gap> DisplayAtlasInfo( "A5", NrMovedPoints, [ 4 .. 9 ] );
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
1: G <= Sym(5)
2: G <= Sym(6)

# from paragraph [ 2, 5, 1, 79 ][ "./interfac.xml", 244 ]

gap> DisplayAtlasInfo( "A5", Dimension, [ 1 .. 3 ] );
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
 8: G <= GL(2a,4)
 9: G <= GL(2b,4)
10: G <= GL(3,5)
12: G <= GL(3a,9)
13: G <= GL(3b,9)
17: G <= GL(3a,Field([Sqrt(5)]))
18: G <= GL(3b,Field([Sqrt(5)]))
gap> DisplayAtlasInfo( "A5", Characteristic, 0 );
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
14: G <= GL(4,Z)
15: G <= GL(5,Z)
16: G <= GL(6,Z)
17: G <= GL(3a,Field([Sqrt(5)]))
18: G <= GL(3b,Field([Sqrt(5)]))

# from paragraph [ 2, 5, 1, 83 ][ "./interfac.xml", 276 ]

gap> DisplayAtlasInfo( "A5", NrMovedPoints, IsPrimeInt );
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
1: G <= Sym(5)
gap> DisplayAtlasInfo( "A5", Characteristic, IsOddInt ); 
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
 6: G <= GL(4,3)
 7: G <= GL(6,3)
10: G <= GL(3,5)
11: G <= GL(5,5)
12: G <= GL(3a,9)
13: G <= GL(3b,9)
gap> DisplayAtlasInfo( "A5", Dimension, IsPrimeInt );     
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
 8: G <= GL(2a,4)
 9: G <= GL(2b,4)
10: G <= GL(3,5)
11: G <= GL(5,5)
12: G <= GL(3a,9)
13: G <= GL(3b,9)
15: G <= GL(5,Z)
17: G <= GL(3a,Field([Sqrt(5)]))
18: G <= GL(3b,Field([Sqrt(5)]))
gap> DisplayAtlasInfo( "A5", Ring, IsFinite and IsPrimeField );
Representations for G = A5:    (all refer to std. generators 1)
---------------------------
 4: G <= GL(4a,2)
 5: G <= GL(4b,2)
 6: G <= GL(4,3)
 7: G <= GL(6,3)
10: G <= GL(3,5)
11: G <= GL(5,5)

# from paragraph [ 2, 5, 1, 87 ][ "./interfac.xml", 325 ]

gap> DisplayAtlasInfo( "A5", IsStraightLineProgram, true );
Programs for G = A5:    (all refer to std. generators 1)
--------------------
available maxes of G:  [ 1 .. 3 ] (all)
standard generators checker available
presentation available

# from paragraph [ 2, 5, 2, 25 ][ "./../gap/interfac.gd", 386 ]

gap> gens1:= AtlasGenerators( "A5", 1 );
rec( generators := [ (1,2)(3,4), (1,3,5) ], groupname := "A5",
  standardization := 1, repnr := 1, 
  identifier := [ "A5", [ "A5G1-p5B0.m1", "A5G1-p5B0.m2" ], 1, 5 ], p := 5, 
  id := "", size := 60 )
gap> gens8:= AtlasGenerators( "A5", 8 );
rec( 
  generators := [ [ [ Z(2)^0, 0*Z(2) ], [ Z(2^2), Z(2)^0 ] ], [ [ 0*Z(2), Z(2
                 )^0 ], [ Z(2)^0, Z(2)^0 ] ] ], groupname := "A5",
  standardization := 1, repnr := 8, 
  identifier := [ "A5", [ "A5G1-f4r2aB0.m1", "A5G1-f4r2aB0.m2" ], 1, 4 ], 
  dim := 2, id := "a", ring := GF(2^2), size := 60 )
gap> gens17:= AtlasGenerators( "A5", 17 );
rec( 
  generators := [ [ [ -1, 0, 0 ], [ 0, -1, 0 ], [ -E(5)-E(5)^4, -E(5)-E(5)^4, 
              1 ] ], [ [ 0, 1, 0 ], [ 0, 0, 1 ], [ 1, 0, 0 ] ] ], 
  groupname := "A5", standardization := 1, repnr := 17, 
  identifier := [ "A5", "A5G1-Ar3aB0.g", 1, 3 ], dim := 3, id := "a", 
  ring := NF(5,[ 1, 4 ]), size := 60 )

# from paragraph [ 2, 5, 2, 30 ][ "./interfac.xml", 356 ]

gap> gens1max2:= AtlasGenerators( "A5", 1, 2 );
rec( generators := [ (1,2)(3,4), (2,3)(4,5) ], standardization := 1, 
  repnr := 1, identifier := [ "A5", [ "A5G1-p5B0.m1", "A5G1-p5B0.m2" ], 1, 5, 
      2 ], p := 5, id := "", size := 10 )
gap> id:= gens1max2.identifier;;
gap> gens1max2 = AtlasGenerators( id );
true
gap> max2:= Group( gens1max2.generators );;
gap> Size( max2 );
10
gap> IdGroup( max2 ) = IdGroup( DihedralGroup( 10 ) );
true

# from paragraph [ 2, 5, 3, 40 ][ "./../gap/interfac.gd", 566 ]

gap> prog:= AtlasProgram( "A5", 2 );
rec( program := <straight line program>, standardization := 1, 
  identifier := [ "A5", "A5G1-max2W1", 1 ], size := 10, groupname := "A5" )
gap> StringOfResultOfStraightLineProgram( prog.program, [ "a", "b" ] );
"[ a, bbab ]"
gap> gens1:= AtlasGenerators( "A5", 1 );
rec( generators := [ (1,2)(3,4), (1,3,5) ], groupname := "A5",
  standardization := 1, repnr := 1, 
  identifier := [ "A5", [ "A5G1-p5B0.m1", "A5G1-p5B0.m2" ], 1, 5 ], p := 5, 
  id := "", size := 60 )
gap> maxgens:= ResultOfStraightLineProgram( prog.program, gens1.generators );
[ (1,2)(3,4), (2,3)(4,5) ]
gap> maxgens = gens1max2.generators;
true

# from paragraph [ 2, 5, 3, 45 ][ "./interfac.xml", 400 ]

gap> prog:= AtlasProgram( "J1", "cyclic" );
rec( program := <straight line program>, standardization := 1, 
  identifier := [ "J1", "J1G1-cycW1", 1 ],
  outputs := [ "6A", "7A", "10B", "11A", "15B", "19A" ], groupname := "J1" )
gap> gens:= GeneratorsOfGroup( FreeGroup( "x", "y" ) );;
gap> ResultOfStraightLineProgram( prog.program, gens );
[ x*y*x*y^2*x*y*x*y^2*x*y*x*y*x*y^2*x*y^2, x*y, x*y*x*y^2*x*y*x*y*x*y^2*x*y^2,
  x*y*x*y*x*y^2*x*y^2*x*y*x*y^2*x*y*x*y*x*y^2*x*y^2*x*y*x*y^2*x*y*x*y*x*y^
    2*x*y^2, x*y*x*y*x*y^2*x*y^2, x*y*x*y^2 ]

# from paragraph [ 2, 5, 4, 10 ][ "./interfac.xml", 429 ]

gap> info:= OneAtlasGeneratingSetInfo( "A5" );
rec( groupname := "A5", standardization := 1, repnr := 1, 
  identifier := [ "A5", [ "A5G1-p5B0.m1", "A5G1-p5B0.m2" ], 1, 5 ], p := 5, 
  id := "", size := 60 )
gap> gens:= AtlasGenerators( info.identifier );
rec( generators := [ (1,2)(3,4), (1,3,5) ], groupname := "A5",
  standardization := 1, repnr := 1, 
  identifier := [ "A5", [ "A5G1-p5B0.m1", "A5G1-p5B0.m2" ], 1, 5 ], p := 5, 
  id := "", size := 60 )
gap> info = OneAtlasGeneratingSetInfo( "A5", IsPermGroup, true );
true
gap> info = OneAtlasGeneratingSetInfo( "A5", NrMovedPoints, "minimal" );
true
gap> info = OneAtlasGeneratingSetInfo( "A5", NrMovedPoints, [ 1 .. 10 ] );
true
gap> OneAtlasGeneratingSetInfo( "A5", NrMovedPoints, 20 );
fail

# from paragraph [ 2, 5, 4, 15 ][ "./interfac.xml", 464 ]

gap> info:= OneAtlasGeneratingSetInfo( "A5", IsMatrixGroup, true );
rec( groupname := "A5", standardization := 1, repnr := 4, 
  identifier := [ "A5", [ "A5G1-f2r4aB0.m1", "A5G1-f2r4aB0.m2" ], 1, 2 ], 
  dim := 4, id := "a", ring := GF(2), size := 60 )
gap> gens:= AtlasGenerators( info.identifier );
rec( 
  generators := [ <an immutable 4x4 matrix over GF2>, <an immutable 4x4 matrix\
 over GF2> ], groupname := "A5", standardization := 1, repnr := 4, 
  identifier := [ "A5", [ "A5G1-f2r4aB0.m1", "A5G1-f2r4aB0.m2" ], 1, 2 ], 
  dim := 4, id := "a", ring := GF(2), size := 60 )
gap> info = OneAtlasGeneratingSetInfo( "A5", Dimension, 4 );
true
gap> info = OneAtlasGeneratingSetInfo( "A5", Characteristic, 2 );
true
gap> info = OneAtlasGeneratingSetInfo( "A5", Ring, GF(2) );
true
gap> OneAtlasGeneratingSetInfo( "A5", Characteristic, [2,5], Dimension, 2 );
rec( groupname := "A5", standardization := 1, repnr := 8, 
  identifier := [ "A5", [ "A5G1-f4r2aB0.m1", "A5G1-f4r2aB0.m2" ], 1, 4 ], 
  dim := 2, id := "a", ring := GF(2^2), size := 60 )
gap> OneAtlasGeneratingSetInfo( "A5", Characteristic, [2,5], Dimension, 1 );
fail
gap> info:= OneAtlasGeneratingSetInfo( "A5", Characteristic, 0, Dimension, 4 );
rec( groupname := "A5", standardization := 1, repnr := 14, 
  identifier := [ "A5", "A5G1-Zr4B0.g", 1, 4 ], dim := 4, id := "", 
  ring := Integers, size := 60 )
gap> gens:= AtlasGenerators( info.identifier );
rec( 
  generators := [ [ [ 1, 0, 0, 0 ], [ 0, 0, 1, 0 ], [ 0, 1, 0, 0 ], [ -1, -1, 
              -1, -1 ] ], 
      [ [ 0, 1, 0, 0 ], [ 0, 0, 0, 1 ], [ 0, 0, 1, 0 ], [ 1, 0, 0, 0 ] ] ], 
  groupname := "A5", standardization := 1, repnr := 14, 
  identifier := [ "A5", "A5G1-Zr4B0.g", 1, 4 ], dim := 4, id := "", 
  ring := Integers, size := 60 )
gap> info = OneAtlasGeneratingSetInfo( "A5", Ring, Integers );
true
gap> info = OneAtlasGeneratingSetInfo( "A5", Ring, CF(37) );
true
gap> OneAtlasGeneratingSetInfo( "A5", Ring, Integers mod 77 );
fail
gap> info:= OneAtlasGeneratingSetInfo( "A5", Ring, CF(5), Dimension, 3 );
rec( groupname := "A5", standardization := 1, repnr := 17, 
  identifier := [ "A5", "A5G1-Ar3aB0.g", 1, 3 ], dim := 3, id := "a", 
  ring := NF(5,[ 1, 4 ]), size := 60 )
gap> gens:= AtlasGenerators( info.identifier );
rec( 
  generators := [ [ [ -1, 0, 0 ], [ 0, -1, 0 ], [ -E(5)-E(5)^4, -E(5)-E(5)^4, 
              1 ] ], [ [ 0, 1, 0 ], [ 0, 0, 1 ], [ 1, 0, 0 ] ] ], 
  groupname := "A5", standardization := 1, repnr := 17, 
  identifier := [ "A5", "A5G1-Ar3aB0.g", 1, 3 ], dim := 3, id := "a", 
  ring := NF(5,[ 1, 4 ]), size := 60 )
gap> OneAtlasGeneratingSetInfo( "A5", Ring, GF(17) );
fail

# from paragraph [ 2, 5, 5, 5 ][ "./../gap/interfac.gd", 694 ]

gap> AllAtlasGeneratingSetInfos( "A5", IsPermGroup, true );
[ rec( groupname := "A5", standardization := 1, repnr := 1, 
      identifier := [ "A5", [ "A5G1-p5B0.m1", "A5G1-p5B0.m2" ], 1, 5 ], 
      p := 5, id := "", size := 60 ),
  rec( groupname := "A5", standardization := 1, repnr := 2, 
      identifier := [ "A5", [ "A5G1-p6B0.m1", "A5G1-p6B0.m2" ], 1, 6 ], 
      p := 6, id := "", size := 60 ),
  rec( groupname := "A5", standardization := 1, repnr := 3, 
      identifier := [ "A5", [ "A5G1-p10B0.m1", "A5G1-p10B0.m2" ], 1, 10 ], 
      p := 10, id := "", size := 60 ) ]

# from paragraph [ 2, 5, 6, 6 ][ "./../gap/interfac.gd", 776 ]

gap> g:= AtlasGroup( "A5" );
Group([ (1,2)(3,4), (1,3,5) ])

# from paragraph [ 2, 5, 7, 6 ][ "./../gap/interfac.gd", 826 ]

gap> g:= AtlasSubgroup( "A5", NrMovedPoints, 5, 1 );
Group([ (1,5)(2,3), (1,3,5) ])
gap> NrMovedPoints( g );
4

# from paragraph [ 2, 6, 1, 5 ][ "./interfac.xml", 544 ]

gap> tbl:= CharacterTable( "M11" );;
gap> modtbl:= tbl mod 2;;
gap> CharacterDegrees( modtbl );
[ [ 1, 1 ], [ 10, 1 ], [ 16, 2 ], [ 44, 1 ] ]

# from paragraph [ 2, 6, 1, 10 ][ "./interfac.xml", 565 ]

gap> DisplayAtlasInfo( "M11", Characteristic, 2 );
Representations for G = M11:    (all refer to std. generators 1)
----------------------------
 6: G <= GL(10,2)
 7: G <= GL(32,2)
 8: G <= GL(44,2)
16: G <= GL(16a,4)
17: G <= GL(16b,4)

# from paragraph [ 2, 6, 1, 14 ][ "./interfac.xml", 588 ]

gap> info:= OneAtlasGeneratingSetInfo( "M11", Characteristic, 2,
>                                             Dimension, 10 );;
gap> gens:= AtlasGenerators( info.identifier );;
gap> ccls:= AtlasProgram( "M11", gens.standardization, "classes" );
rec( program := <straight line program>, standardization := 1,
  identifier := [ "M11", "M11G1-cclsW1", 1 ],
  outputs := [ "1A", "2A", "3A", "4A", "5A", "6A", "8A", "8B", "11A", "11B" ],
  groupname := "M11" )
gap> reps:= ResultOfStraightLineProgram( ccls.program, gens.generators );;

# from paragraph [ 2, 6, 1, 18 ][ "./interfac.xml", 610 ]

gap> ord8prg:= RestrictOutputsOfSLP( ccls.program,
>                   Filtered( [ 1 .. 10 ], i -> ccls.outputs[i][1] = '8' ) );
<straight line program>
gap> ord8reps:= ResultOfStraightLineProgram( ord8prg, gens.generators );;
gap> List( ord8reps, m -> Position( reps, m ) );
[ 7, 8 ]

# from paragraph [ 2, 6, 1, 22 ][ "./interfac.xml", 625 ]

gap> List( reps, Order ) = OrdersClassRepresentatives( tbl );
true

# from paragraph [ 2, 6, 1, 26 ][ "./interfac.xml", 643 ]

gap> fus:= GetFusionMap( modtbl, tbl );
[ 1, 3, 5, 9, 10 ]
gap> modreps:= reps{ fus };;

# from paragraph [ 2, 6, 1, 30 ][ "./interfac.xml", 657 ]

gap> char:= List( modreps, BrauerCharacterValue );
[ 10, 1, 0, -1, -1 ]
gap> Position( Irr( modtbl ), char );
2

# from paragraph [ 2, 6, 2, 5 ][ "./interfac.xml", 679 ]

gap> grp:= Group( gens.generators );;
gap> v:= GF(2)^10;;
gap> orbs:= Orbits( grp, AsList( v ) );;
gap> List( orbs, Length );
[ 1, 396, 55, 330, 66, 165, 11 ]

# from paragraph [ 2, 6, 2, 10 ][ "./interfac.xml", 707 ]

gap> gens:= AtlasGenerators( "M11", 6, 1 );;

# from paragraph [ 2, 6, 2, 14 ][ "./interfac.xml", 713 ]

gap> id:= IdentityMat( 10, GF(2) );;
gap> sub1:= Subspace( v, NullspaceMat( gens.generators[1] - id ) );;
gap> sub2:= Subspace( v, NullspaceMat( gens.generators[2] - id ) );;
gap> fix:= Intersection( sub1, sub2 );
<vector space of dimension 1 over GF(2)>

# from paragraph [ 2, 6, 2, 18 ][ "./interfac.xml", 728 ]

gap> orb:= Orbit( grp, Basis( fix )[1] );;
gap> act:= Action( grp, orb );;  Print( act, "\n" );
Group( [ ( 1, 2)( 4, 6)( 5, 8)( 7,10), ( 1, 3, 5, 9)( 2, 4, 7,11) ] )

# from paragraph [ 2, 6, 2, 22 ][ "./interfac.xml", 743 ]

gap> permgrp:= Group( AtlasGenerators( "M11", 1 ).generators );;
gap> Print( permgrp, "\n" );
Group( [ ( 2,10)( 4,11)( 5, 7)( 8, 9), ( 1, 4, 3, 8)( 2, 5, 6, 9) ] )
gap> permgrp = act;
false
gap> IsConjugate( SymmetricGroup(11), permgrp, act );
true

# from paragraph [ 2, 6, 3, 5 ][ "./interfac.xml", 766 ]

gap> DisplayAtlasInfo( "G2(3)", IsStraightLineProgram );
Programs for G = G2(3):    (all refer to std. generators 1)
-----------------------
available maxes of G:  [ 1 .. 10 ] (all)
class repres. of G available
repres. of cyclic subgroups of G available
available automorphisms:  [ "2" ]
standard generators checker available
presentation available
gap> prog:= AtlasProgram( "G2(3)", "automorphism", "2" ).program;;
gap> info:= OneAtlasGeneratingSetInfo( "G2(3)", Dimension, 7 );;
gap> gens:= AtlasGenerators( info ).generators;;
gap> imgs:= ResultOfStraightLineProgram( prog, gens );;

# from paragraph [ 2, 6, 3, 9 ][ "./interfac.xml", 793 ]

gap> g:= Group( gens );;
gap> aut:= GroupHomomorphismByImagesNC( g, g, gens, imgs );;
gap> SetIsBijective( aut, true );

# from paragraph [ 2, 6, 3, 13 ][ "./interfac.xml", 806 ]

gap> aut:= GroupHomomorphismByImages( g, g, gens, imgs );;
gap> IsBijective( aut );
true

# from paragraph [ 2, 6, 3, 18 ][ "./interfac.xml", 833 ]

gap> max1:= AtlasProgram( "G2(3)", 1 ).program;;
gap> mgens:= ResultOfStraightLineProgram( max1, gens );;
gap> comp:= CompositionOfStraightLinePrograms( max1, prog );;
gap> mimgs:= ResultOfStraightLineProgram( comp, gens );;

# from paragraph [ 2, 6, 3, 22 ][ "./interfac.xml", 853 ]

gap> mimgs = List( mgens, x -> x^aut );
true

# from paragraph [ 2, 6, 4, 5 ][ "./interfac.xml", 887 ]

gap> info:= OneAtlasGeneratingSetInfo( "M12", NrMovedPoints, 12 );
rec( groupname := "M12", standardization := 1, repnr := 1, 
  identifier := [ "M12", [ "M12G1-p12aB0.m1", "M12G1-p12aB0.m2" ], 1, 12 ], 
  p := 12, id := "a", size := 95040 )
gap> gensM12:= AtlasGenerators( info.identifier );;
gap> restM11:= AtlasProgram( "M12", "maxes", 1 );;
gap> gensM11:= ResultOfStraightLineProgram( restM11.program,
>                                           gensM12.generators );
[ (3,9)(4,12)(5,10)(6,8), (1,4,11,5)(2,10,8,3) ]

# from paragraph [ 2, 6, 4, 9 ][ "./interfac.xml", 908 ]

gap> checkM11:= AtlasProgram( "M11", "check" );
rec( program := <straight line decision>, standardization := 1, 
  identifier := [ "M11", "M11G1-check1", 1, 1 ], groupname := "M11" )
gap> ResultOfStraightLineDecision( checkM11.program, gensM11 );
true

# from paragraph [ 2, 6, 4, 13 ][ "./interfac.xml", 923 ]

gap> restL211:= AtlasProgram( "M11", "maxes", 2 );;
gap> gensL211:= ResultOfStraightLineProgram( restL211.program, gensM11 );
[ (3,9)(4,12)(5,10)(6,8), (1,11,9)(2,12,8)(3,6,10) ]
gap> G:= Group( gensL211 );;  Size( G );  IsSimple( G );
660
true

# from paragraph [ 2, 6, 4, 17 ][ "./interfac.xml", 940 ]

gap> G:= MathieuGroup( 11 );;
gap> gens:= GeneratorsOfGroup( G );
[ (1,2,3,4,5,6,7,8,9,10,11), (3,7,11,8)(4,10,5,6) ]
gap> ResultOfStraightLineDecision( checkM11.program, gens );   
false

# from paragraph [ 2, 6, 4, 21 ][ "./interfac.xml", 956 ]

gap> find:= AtlasProgram( "M11", "find" );
rec( program := <black box program>, standardization := 1, 
  identifier := [ "M11", "M11G1-find1", 1, 1 ], groupname := "M11" )
gap> stdgens:= ResultOfBBoxProgram( find.program, Group( gens ) );;
gap> List( stdgens, Order );
[ 2, 4 ]
gap> ResultOfStraightLineDecision( checkM11.program, stdgens );
true
gap> gensL211:= ResultOfStraightLineProgram( restL211.program, stdgens );;
gap> List( gensL211, Order );
[ 2, 3 ]
gap> G:= Group( gensL211 );;  Size( G );  IsSimple( G );
660
true

# from paragraph [ 2, 6, 5, 5 ][ "./interfac.xml", 991 ]

gap> tom:= TableOfMarks( "A5" );
TableOfMarks( "A5" )
gap> info:= StandardGeneratorsInfo( tom );
[ rec( generators := "a, b", description := "|a|=2, |b|=3, |ab|=5", 
      script := [ [ 1, 2 ], [ 2, 3 ], [ 1, 1, 2, 1, 5 ] ], ATLAS := true ) ]

# from paragraph [ 2, 6, 5, 10 ][ "./interfac.xml", 1014 ]

gap> info:= OneAtlasGeneratingSetInfo( "A5", Ring, Integers, Dimension, 4 );;
gap> stdgens:= AtlasGenerators( info.identifier );
rec( 
  generators := [ [ [ 1, 0, 0, 0 ], [ 0, 0, 1, 0 ], [ 0, 1, 0, 0 ], [ -1, -1, 
              -1, -1 ] ], 
      [ [ 0, 1, 0, 0 ], [ 0, 0, 0, 1 ], [ 0, 0, 1, 0 ], [ 1, 0, 0, 0 ] ] ], 
  groupname := "A5", standardization := 1, repnr := 14, 
  identifier := [ "A5", "A5G1-Zr4B0.g", 1, 4 ], dim := 4, id := "", 
  ring := Integers, size := 60 )
gap> orders:= OrdersTom( tom );
[ 1, 2, 3, 4, 5, 6, 10, 12, 60 ]
gap> pos:= Position( orders, 4 );
4
gap> sub:= RepresentativeTomByGeneratorsNC( tom, pos, stdgens.generators );
<matrix group of size 4 with 2 generators>
gap> GeneratorsOfGroup( sub );
[ [ [ 1, 0, 0, 0 ], [ -1, -1, -1, -1 ], [ 0, 0, 0, 1 ], [ 0, 0, 1, 0 ] ], 
  [ [ 1, 0, 0, 0 ], [ 0, 0, 1, 0 ], [ 0, 1, 0, 0 ], [ -1, -1, -1, -1 ] ] ]

# from paragraph [ 3, 3, 0, 4 ][ "./extend.xml", 127 ]

gap> level:= InfoLevel( InfoAtlasRep );;
gap> SetInfoLevel( InfoAtlasRep, 1 );

# from paragraph [ 3, 3, 0, 21 ][ "./extend.xml", 173 ]

gap> pkg:= Filename( DirectoriesPackageLibrary( "atlasrep", "" ), "" );;
gap> prv:= DirectoryTemporary( "privdir" );;
gap> FileString( Filename( prv, "C4G1-p4B0.m1" ),
>                MeatAxeString( [ (1,2,3,4) ], 4 ) );;
gap> FileString( Filename( prv, "C4G1-max1W1" ),
>                "inp 1\npwr 2 1 2\noup 1 2\n" );;
gap> FileString( Filename( prv, "C4G1-XtestW1" ),
>                "inp 1\npwr 2 1 2\noup 1 2\n" );;
gap> FileString( Filename( prv, "C4G1-a2W1" ),
>                "inp 1\npwr 3 1 2\noup 1 2\n" );;
gap> FileString( Filename( prv, "C4G1-Ar1aB0.g" ),
>                "return rec( generators:= [ [[E(4)]] ] );\n" );;
gap> FileString( Filename( prv, "S5G1-p2B0.m1" ),
>                MeatAxeString( [ (1,2) ], 2 ) );;
gap> FileString( Filename( prv, "S5G1-p2B0.m2" ),
>                MeatAxeString( [ (1,2) ], 2 ) );;

# from paragraph [ 3, 3, 0, 26 ][ "./extend.xml", 207 ]

gap> FileString( Filename( prv, "S5G1-p5B0.m1" ),
>                MeatAxeString( [ (1,2) ], 5 ) );;

# from paragraph [ 3, 3, 0, 30 ][ "./extend.xml", 222 ]

gap> FileString( Filename( prv, "toc.g" ),
>                "AGRGNAN(\"C4\",\"C4\");\n" );;

# from paragraph [ 3, 3, 0, 34 ][ "./extend.xml", 233 ]

gap> AtlasOfGroupRepresentationsNotifyPrivateDirectory( prv, "priv" );
#I  file `S5G1-p5B0.m1' was already in another t.o.c.
false

# from paragraph [ 3, 3, 0, 38 ][ "./extend.xml", 251 ]

gap> DisplayAtlasInfo( [ "C4" ] );
group    #  maxes  cl  cyc  out  find  check  pres
--------------------------------------------------
C4*      2      1   -    -    2     -      -     -
gap> DisplayAtlasInfo( "C4" );
Representations for G = C4:    (all refer to std. generators 1)
---------------------------
1: G <= Sym(4)*
2: G <= GL(1a,C)*

Programs for G = C4:    (all refer to std. generators 1)
--------------------
available maxes of G:  [ 1 ]*
available automorphisms:  [ "2" ]*
available other scripts:
   "test"*
gap> DisplayAtlasInfo( "C4", IsPermGroup, true );
Representations for G = C4:    (all refer to std. generators 1)
---------------------------
1: G <= Sym(4)*
gap> DisplayAtlasInfo( "C4", IsMatrixGroup );
Representations for G = C4:    (all refer to std. generators 1)
---------------------------
2: G <= GL(1a,C)*
gap> DisplayAtlasInfo( "C4", Dimension, 2 );
gap> DisplayAtlasInfo( "A5.2", NrMovedPoints, 2 );
Representations for G = A5.2:    (all refer to std. generators 1)
-----------------------------
4: G <= Sym(2)*
gap> info:= OneAtlasGeneratingSetInfo( "C4" );
rec( groupname := "C4", standardization := 1, repnr := 1, 
  identifier := [ [ "priv", "C4" ], [ "C4G1-p4B0.m1" ], 1, 4 ], p := 4, 
  id := "" )
gap> AtlasGenerators( info.identifier );
rec( generators := [ (1,2,3,4) ], groupname := "C4", standardization := 1,
  repnr := 1, identifier := [ [ "priv", "C4" ], [ "C4G1-p4B0.m1" ], 1, 4 ], 
  p := 4, id := "" )
gap> AtlasProgram( "C4", 1 );
rec( program := <straight line program>, standardization := 1, 
  identifier := [ [ "priv", "C4" ], "C4G1-max1W1", 1 ], groupname := "C4" )
gap> AtlasProgram( "C4", "maxes", 1 );
rec( program := <straight line program>, standardization := 1, 
  identifier := [ [ "priv", "C4" ], "C4G1-max1W1", 1 ], groupname := "C4" )
gap> AtlasProgram( "C4", "maxes", 2 );
fail
gap> AtlasGenerators( "C4", 1 );
rec( generators := [ (1,2,3,4) ], groupname := "C4", standardization := 1,
  repnr := 1, identifier := [ [ "priv", "C4" ], [ "C4G1-p4B0.m1" ], 1, 4 ], 
  p := 4, id := "" )
gap> AtlasGenerators( "C4", 2 );
rec( generators := [ [ [ E(4) ] ] ], groupname := "C4", standardization := 1,
  repnr := 2, identifier := [ [ "priv", "C4" ], "C4G1-Ar1aB0.g", 1, 1 ], 
  dim := 1, id := "a" )
gap> AtlasGenerators( "C4", 3 );
fail
gap> AtlasProgram( "C4", "other", "test" );
rec( program := <straight line program>, standardization := 1, 
  identifier := [ [ "priv", "C4" ], "C4G1-XtestW1", 1 ], groupname := "C4" )

# from paragraph [ 3, 3, 0, 42 ][ "./extend.xml", 320 ]

gap> AtlasOfGroupRepresentationsTestWords( "priv" );
true
gap> AtlasOfGroupRepresentationsTestFileHeaders( "priv" );
true

# from paragraph [ 3, 3, 0, 46 ][ "./extend.xml", 338 ]

gap> AtlasOfGroupRepresentationsForgetPrivateDirectory( "priv" );
gap> SetInfoLevel( InfoAtlasRep, level );

# from paragraph [ 4, 1, 2, 5 ][ "./../gap/bbox.gd", 549 ]

gap> dec:= StraightLineDecision( [ [ [ 1, 1, 2, 1 ], 3 ],
> [ "Order", 1, 2 ], [ "Order", 2, 3 ], [ "Order", 3, 5 ] ] );
<straight line decision>
gap> LinesOfStraightLineDecision( dec );
[ [ [ 1, 1, 2, 1 ], 3 ], [ "Order", 1, 2 ], [ "Order", 2, 3 ], 
  [ "Order", 3, 5 ] ]

# from paragraph [ 4, 1, 3, 5 ][ "./../gap/bbox.gd", 579 ]

gap> NrInputsOfStraightLineDecision( dec );
2

# from paragraph [ 4, 1, 4, 11 ][ "./../gap/scanmtx.gd", 611 ]

gap> str:= "inp 2\nchor 1 2\nchor 2 3\nmu 1 2 3\nchor 3 5";;
gap> prg:= ScanStraightLineDecision( str );
rec( program := <straight line decision> )
gap> prg:= prg.program;;
gap> Display( prg );
# input:
r:= [ g1, g2 ];
# program:
if Order( r[1] ) <> 2 then  return false;  fi;
if Order( r[2] ) <> 3 then  return false;  fi;
r[3]:= r[1]*r[2];
if Order( r[3] ) <> 5 then  return false;  fi;
# return value:
true

# from paragraph [ 4, 1, 6, 17 ][ "./../gap/bbox.gd", 646 ]

gap> dec:= StraightLineDecision( [ ], 1 );
<straight line decision>
gap> ResultOfStraightLineDecision( dec, [ () ] );
true

# from paragraph [ 4, 1, 6, 21 ][ "./../gap/bbox.gd", 656 ]

gap> dec:= StraightLineDecision( [ [ [ 1, 1, 2, 1 ], 3 ],
>       [ "Order", 1, 2 ], [ "Order", 2, 3 ], [ "Order", 3, 5 ] ] );
<straight line decision>
gap> LinesOfStraightLineDecision( dec );
[ [ [ 1, 1, 2, 1 ], 3 ], [ "Order", 1, 2 ], [ "Order", 2, 3 ], 
  [ "Order", 3, 5 ] ]
gap> ResultOfStraightLineDecision( dec, [ (), () ] );
false
gap> ResultOfStraightLineDecision( dec, [ (1,2)(3,4), (1,4,5) ] );
true

# from paragraph [ 4, 1, 7, 18 ][ "./../gap/bbox.gd", 761 ]

gap> check:= AtlasProgram( "L2(8)", "check" );
rec( program := <straight line decision>, standardization := 1, 
  identifier := [ "L2(8)", "L28G1-check1", 1, 1 ], groupname := "L2(8)" )
gap> gens:= AtlasGenerators( "L2(8)", 1 );
rec( generators := [ (1,2)(3,4)(6,7)(8,9), (1,3,2)(4,5,6)(7,8,9) ], 
  groupname := "L2(8)", standardization := 1, repnr := 1, 
  identifier := [ "L2(8)", [ "L28G1-p9B0.m1", "L28G1-p9B0.m2" ], 1, 9 ], 
  p := 9, id := "", size := 504 )
gap> ResultOfStraightLineDecision( check.program, gens.generators );
true
gap> gens:= AtlasGenerators( "L3(2)", 1 );
rec( generators := [ (2,4)(3,5), (1,2,3)(5,6,7) ], groupname := "L3(2)", 
  standardization := 1, repnr := 1, 
  identifier := [ "L3(2)", [ "L27G1-p7aB0.m1", "L27G1-p7aB0.m2" ], 1, 7 ], 
  p := 7, id := "a", size := 168 )
gap> ResultOfStraightLineDecision( check.program, gens.generators );
true

# from paragraph [ 4, 1, 8, 5 ][ "./../gap/bbox.gd", 967 ]

gap> lines:= [ [ "Order", 1, 2 ], [ "Order", 2, 3 ],
>              [ [ 1, 1, 2, 1 ], 3 ], [ "Order", 3, 5 ] ];;
gap> dec:= StraightLineDecision( lines, 2 );
<straight line decision>
gap> bboxdec:= AsBBoxProgram( dec );
<black box program>
gap> asdec:= AsStraightLineDecision( bboxdec );
<straight line decision>
gap> LinesOfStraightLineDecision( asdec );
[ [ "Order", 1, 2 ], [ "Order", 2, 3 ], [ [ 1, 1, 2, 1 ], 3 ], 
  [ "Order", 3, 5 ] ]

# from paragraph [ 4, 1, 9, 7 ][ "./../gap/bbox.gd", 817 ]

gap> dec:= StraightLineDecision( [ [ [ 1, 1, 2, 1 ], 3 ],
> [ "Order", 1, 2 ], [ "Order", 2, 3 ], [ "Order", 3, 5 ] ] );
<straight line decision>
gap> prog:= StraightLineProgramFromStraightLineDecision( dec );
<straight line program>
gap> Display( prog );
# input:
r:= [ g1, g2 ];
# program:
r[3]:= r[1]*r[2];
r[4]:= r[1]^2;
r[5]:= r[2]^3;
r[6]:= r[3]^5;
# return values:
[ r[4], r[5], r[6] ]
gap> StringOfResultOfStraightLineProgram( prog, [ "a", "b" ] );
"[ a^2, b^3, (ab)^5 ]"
gap> gens:= GeneratorsOfGroup( FreeGroup( "a", "b" ) );
[ a, b ]
gap> ResultOfStraightLineProgram( prog, gens );
[ a^2, b^3, a*b*a*b*a*b*a*b*a*b ]

# from paragraph [ 4, 2, 2, 6 ][ "./../gap/bbox.gd", 194 ]

gap> findstr:= "\
>   set V 0\n\
> lbl START1\n\
>   rand 1\n\
>   ord 1 A\n\
>   incr V\n\
>   if V gt 100 then timeout\n\
>   if A notin 1 2 3 5 then fail\n\
>   if A noteq 2 then jmp START1\n\
> lbl START2\n\
>   rand 2\n\
>   ord 2 B\n\
>   incr V\n\
>   if V gt 100 then timeout\n\
>   if B notin 1 2 3 5 then fail\n\
>   if B noteq 3 then jmp START2\n\
>   # The elements 1 and 2 have the orders 2 and 3, respectively.\n\
>   set X 0\n\
> lbl CONJ\n\
>   incr X\n\
>   if X gt 100 then timeout\n\
>   rand 3\n\
>   cjr 2 3\n\
>   mu 1 2 4   # ab\n\
>   ord 4 C\n\
>   if C notin 2 3 5 then fail\n\
>   if C noteq 5 then jmp CONJ\n\
>   oup 2 1 2";;
gap> find:= ScanBBoxProgram( findstr );
rec( program := <black box program> )

# from paragraph [ 4, 2, 2, 10 ][ "./../gap/bbox.gd", 230 ]

gap> checkstr:= "\
> chor 1 2\n\
> chor 2 3\n\
> mu 1 2 3\n\
> chor 3 5";;
gap> check:= ScanBBoxProgram( checkstr );
rec( program := <black box program> )

# from paragraph [ 4, 2, 3, 29 ][ "./../gap/bbox.gd", 332 ]

gap> g:= AlternatingGroup( 5 );;
gap> res:= RunBBoxProgram( find.program, g, [], rec() );;
gap> IsBound( res.gens );  IsBound( res.result );
true
false
gap> List( res.gens, Order );
[ 2, 3 ]
gap> Order( Product( res.gens ) );
5
gap> res:= RunBBoxProgram( check.program, "dummy", res.gens, rec() );;
gap> IsBound( res.gens );  IsBound( res.result );
false
true
gap> res.result;
true
gap> othergens:= GeneratorsOfGroup( g );;
gap> res:= RunBBoxProgram( check.program, "dummy", othergens, rec() );;
gap> res.result;
false

# from paragraph [ 4, 2, 4, 6 ][ "./../gap/bbox.gd", 384 ]

gap> g:= AlternatingGroup( 5 );;
gap> res:= ResultOfBBoxProgram( find.program, g );;
gap> List( res, Order );
[ 2, 3 ]
gap> Order( Product( res ) );
5
gap> res:= ResultOfBBoxProgram( check.program, res );
true
gap> othergens:= GeneratorsOfGroup( g );;
gap> res:= ResultOfBBoxProgram( check.program, othergens );
false

# from paragraph [ 4, 2, 5, 5 ][ "./../gap/bbox.gd", 873 ]

gap> f:= FreeGroup( "x", "y" );;  gens:= GeneratorsOfGroup( f );;
gap> slp:= StraightLineProgram( [ [1,2,2,3], [3,-1] ], 2 );
<straight line program>
gap> ResultOfStraightLineProgram( slp, gens );
y^-3*x^-2
gap> bboxslp:= AsBBoxProgram( slp );
<black box program>
gap> ResultOfBBoxProgram( bboxslp, gens );
[ y^-3*x^-2 ]
gap> lines:= [ [ "Order", 1, 2 ], [ "Order", 2, 3 ],
>              [ [ 1, 1, 2, 1 ], 3 ], [ "Order", 3, 5 ] ];;
gap> dec:= StraightLineDecision( lines, 2 );
<straight line decision>
gap> ResultOfStraightLineDecision( dec, [ (1,2)(3,4), (1,3,5) ] );
true
gap> ResultOfStraightLineDecision( dec, [ (1,2)(3,4), (1,3,4) ] );
false
gap> bboxdec:= AsBBoxProgram( dec );
<black box program>
gap> ResultOfBBoxProgram( bboxdec, [ (1,2)(3,4), (1,3,5) ] );
true
gap> ResultOfBBoxProgram( bboxdec, [ (1,2)(3,4), (1,3,4) ] );
false

# from paragraph [ 4, 2, 6, 5 ][ "./../gap/bbox.gd", 926 ]

gap> Display( AsStraightLineProgram( bboxslp ) );
# input:
r:= [ g1, g2 ];
# program:
r[3]:= r[1]^2;
r[4]:= r[2]^3;
r[5]:= r[3]*r[4];
r[3]:= r[5]^-1;
# return values:
[ r[3] ]
gap> AsStraightLineProgram( bboxdec );
fail

# from paragraph [ 4, 3, 1, 29 ][ "./../gap/mindeg.gd", 194 ]

gap> MinimalRepresentationInfo( "A5", NrMovedPoints );
rec( value := 5,
  source := [ "computed (alternating group)", "computed (char. table)",
      "computed (subgroup tables)",
      "computed (subgroup tables, known repres.)",
      "computed (table of marks)" ] )
gap> MinimalRepresentationInfo( "A5", Characteristic, 2 );
rec( value := 2, source := [ "computed (char. table)" ] )
gap> MinimalRepresentationInfo( "A5", Size, 2 );
rec( value := 4, source := [ "computed (char. table)" ] )

# from paragraph [ 4, 3, 3, 19 ][ "./../gap/mindeg.gd", 337 ]

gap> SetMinimalRepresentationInfo( "A5", "NrMovedPoints", 5,
>      "computed (alternating group)" );
true
gap> SetMinimalRepresentationInfo( "A5", [ "Characteristic", 0 ], 3,
>      "computed (char. table)" );
true
gap> SetMinimalRepresentationInfo( "A5", [ "Characteristic", 2 ], 2,
>      "computed (char. table)" );
true
gap> SetMinimalRepresentationInfo( "A5", [ "Size", 2 ], 4,
>      "computed (char. table)" );
true
gap> SetMinimalRepresentationInfo( "A5", [ "Size", 4 ], 2,
>      "computed (char. table)" );
true
gap> SetMinimalRepresentationInfo( "A5", [ "Characteristic", 3 ], 3,
>      "computed (char. table)" );
true

# from paragraph [ 4, 3, 6, 5 ][ "./../gap/brmindeg.g", 33 ]

gap> if LoadPackage( "browse", "1.2" ) = true then
>   down:= NCurses.keys.DOWN;;  DOWN:= NCurses.keys.NPAGE;;
>   right:= NCurses.keys.RIGHT;;  END:= NCurses.keys.END;;
>   enter:= NCurses.keys.ENTER;;  nop:= [ 14, 14, 14 ];;
>   # just scroll in the table
>   BrowseData.SetReplay( Concatenation( [ DOWN, DOWN, DOWN,
>          right, right, right ], "sedddrrrddd", nop, nop, "Q" ) );
>   BrowseMinimalDegrees();;
>   # restrict the table to the groups with minimal ordinary degree 6
>   BrowseData.SetReplay( Concatenation( "scf6",
>        [ down, down, right, enter, enter ] , nop, nop, "Q" ) );
>   BrowseMinimalDegrees();;
>   BrowseData.SetReplay( false );
> fi;

# from paragraph [ 4, 3, 6, 9 ][ "./../gap/brmindeg.g", 59 ]

gap> if LoadPackage( "browse", "1.2" ) = true then
>   # just scroll in the table
>   BrowseData.SetReplay( Concatenation( [ DOWN, DOWN, DOWN, END ],
>          "rrrrrrrrrrrrrr", nop, nop, "Q" ) );
>   BrowseMinimalDegrees( BibliographySporadicSimple.groupNamesJan05 );;
> fi;

# from paragraph [ 4, 4, 1, 8 ][ "./../gap/brspor.g", 192 ]

gap> if LoadPackage( "browse", "1.2" ) = true then
>   enter:= NCurses.keys.ENTER;;  nop:= [ 14, 14, 14 ];;
>   BrowseData.SetReplay( Concatenation(
>     # choose the application
>     "/Bibliography of Sporadic Simple Groups", [ enter, enter ],
>     # search in the title column for the Atlas of Finite Groups
>     "scr/Atlas of finite groups", [ enter,
>     # and quit
>     nop, nop, nop, nop ], "Q" ) );
>   BrowseGapData();;
>   BrowseData.SetReplay( false );
> fi;

# from paragraph [ 5, 3, 2, 12 ][ "./../gap/scanmtx.gd", 305 ]

gap> mat:= [ [ 1, -1 ], [ 0, 1 ] ] * Z(3)^0;;
gap> str:= MeatAxeString( mat, 3 );
"1 3 2 2\n12\n01\n"
gap> mat = ScanMeatAxeFile( str, "string" );
true
gap> str:= MeatAxeString( mat, 9 );
"1 9 2 2\n12\n01\n"
gap> mat = ScanMeatAxeFile( str, "string" );
true
gap> perms:= [ (1,2,3)(5,6) ];;
gap> str:= MeatAxeString( perms, 6 );
"12 1 6 1\n2\n3\n1\n4\n6\n5\n"
gap> perms = ScanMeatAxeFile( str, "string" );
true
gap> str:= MeatAxeString( perms, 8 );
"12 1 8 1\n2\n3\n1\n4\n6\n5\n7\n8\n"
gap> perms = ScanMeatAxeFile( str, "string" );
true
gap> perm:= (1,2,4);;
gap> str:= MeatAxeString( perm, 3, [ 5, 6 ] );
"2 3 5 6\n2\n4\n3\n1\n5\n"
gap> mat:= ScanMeatAxeFile( str, "string" );;  Print( mat, "\n" );
[ [ 0*Z(3), Z(3)^0, 0*Z(3), 0*Z(3), 0*Z(3), 0*Z(3) ], 
  [ 0*Z(3), 0*Z(3), 0*Z(3), Z(3)^0, 0*Z(3), 0*Z(3) ], 
  [ 0*Z(3), 0*Z(3), Z(3)^0, 0*Z(3), 0*Z(3), 0*Z(3) ], 
  [ Z(3)^0, 0*Z(3), 0*Z(3), 0*Z(3), 0*Z(3), 0*Z(3) ], 
  [ 0*Z(3), 0*Z(3), 0*Z(3), 0*Z(3), Z(3)^0, 0*Z(3) ] ]
gap> MeatAxeString( mat, 3 ) = str;
true

# from paragraph [ 5, 3, 3, 10 ][ "./../gap/scanmtx.gd", 112 ]

gap> FFList( GF(4) );
[ 0*Z(2), Z(2)^0, Z(2^2), Z(2^2)^2 ]
gap> IsBound( FFLists[4] );
true

# from paragraph [ 5, 3, 4, 6 ][ "./../gap/scanmtx.gd", 371 ]

gap> tmpdir:= DirectoryTemporary();;
gap> mat:= Filename( tmpdir, "mat" );;
gap> q:= 4;;
gap> mats:= GeneratorsOfGroup( GL(10,q) );;
gap> CMtxBinaryFFMatOrPerm( mats[1], q, Concatenation( mat, "1" ) );
gap> CMtxBinaryFFMatOrPerm( mats[2], q, Concatenation( mat, "2" ) );
gap> prm:= Filename( tmpdir, "prm" );;
gap> n:= 200;;
gap> perms:= GeneratorsOfGroup( SymmetricGroup( n ) );;
gap> CMtxBinaryFFMatOrPerm( perms[1], n, Concatenation( prm, "1" ) );
gap> CMtxBinaryFFMatOrPerm( perms[2], n, Concatenation( prm, "2" ) );

# from paragraph [ 5, 3, 5, 5 ][ "./../gap/scanmtx.gd", 410 ]

gap> FFMatOrPermCMtxBinary( Concatenation( mat, "1" ) ) = mats[1];
true
gap> FFMatOrPermCMtxBinary( Concatenation( mat, "2" ) ) = mats[2];
true
gap> FFMatOrPermCMtxBinary( Concatenation( prm, "1" ) ) = perms[1];
true
gap> FFMatOrPermCMtxBinary( Concatenation( prm, "2" ) ) = perms[2];
true

# from paragraph [ 5, 4, 2, 10 ][ "./../gap/scanmtx.gd", 676 ]

gap> str:= "inp 2\nmu 1 2 3\nmu 3 1 2\niv 2 1\noup 2 1 2";;
gap> prg:= ScanStraightLineProgram( str, "string" );
rec( program := <straight line program> )
gap> prg:= prg.program;;
gap> Display( prg );
# input:
r:= [ g1, g2 ];
# program:
r[3]:= r[1]*r[2];
r[2]:= r[3]*r[1];
r[1]:= r[2]^-1;
# return values:
[ r[1], r[2] ]
gap> StringOfResultOfStraightLineProgram( prg, [ "a", "b" ] );
"[ (aba)^-1, aba ]"
gap> AtlasStringOfProgram( prg );
"inp 2\nmu 1 2 3\nmu 3 1 2\niv 2 1\noup 2\n"
gap> prg:= StraightLineProgram( "(a^2b^3)^-1", [ "a", "b" ] );
<straight line program>
gap> Print( AtlasStringOfProgram( prg ) );
inp 2
pwr 2 1 4
pwr 3 2 5
mu 4 5 3
iv 3 4
oup 1 4
gap> prg:= StraightLineProgram( [ [2,3], [ [3,1,1,4], [1,2,3,1] ] ], 2 );
<straight line program>
gap> Print( AtlasStringOfProgram( prg ) );
inp 2
pwr 3 2 3
pwr 4 1 5
mu 3 5 4
pwr 2 1 6
mu 6 3 5
oup 2 4 5
gap> Print( AtlasStringOfProgram( prg, "mtx" ) );
# inputs are expected in 1 2
zsm pwr3 2 3
zsm pwr4 1 5
zmu 3 5 4
zsm pwr2 1 6
zmu 6 3 5
echo "outputs are in 4 5"
gap> str:= "inp 2\nchor 1 2\nchor 2 3\nmu 1 2 3\nchor 3 5";;
gap> prg:= ScanStraightLineDecision( str );;
gap> AtlasStringOfProgram( prg.program );
"inp 2\nchor 1 2\nchor 2 3\nmu 1 2 3\nchor 3 5\n"

# from paragraph [ 5, 6, 1, 6 ][ "./../gap/access.gd", 151 ]

gap> format:= [ [ [ IsChar, "G", IsDigitChar ],
>                 [ "p", IsDigitChar, IsLowerAlphaOrDigitChar,
>                   "B", IsDigitChar, ".m", IsDigitChar ] ],
>               [ ParseBackwards, ParseForwards ] ];;
gap> AGRParseFilenameFormat( "A6G1-p10B0.m1", format );
[ "A6", "G", 1, "p", 10, "", "B", 0, ".m", 1 ]
gap> AGRParseFilenameFormat( "A6G1-p15aB0.m1", format );
[ "A6", "G", 1, "p", 15, "a", "B", 0, ".m", 1 ]
gap> AGRParseFilenameFormat( "A6G1-f2r16B0.m1", format );
fail



gap> STOP_TEST( "docxpl.tst", 10000000 );


#############################################################################
##
#E

