#############################################################################
##
#W  PackageInfo.g           The CIRCLE package            Alexander Konovalov
##                                                          Panagiotis Soules
##
#H  $Id: PackageInfo.g,v 1.12 2008/01/18 15:54:38 alexk Exp $
##
#############################################################################

SetPackageInfo( rec(

PackageName := "Circle",
Subtitle := "Adjoint groups of finite rings",
Version := "1.3.1",
Date := "17/01/2008",
ArchiveURL := "http://www.cs.st-andrews.ac.uk/~alexk/circle/circle-1.3.1",
ArchiveFormats := ".tar.gz .tar.bz2 -win.zip",

#TextFiles := ["init.g", ......],
#BinaryFiles := ["doc/manual.dvi", ......],

Persons := [
  rec(
    LastName      := "Konovalov",
    FirstNames    := "Alexander",
    IsAuthor      := true,
    IsMaintainer  := true,
    Email         := "konovalov@member.ams.org",
    WWWHome       := "http://www.cs.st-andrews.ac.uk/~alexk/",
    PostalAddress := Concatenation( [
                     "School of Computer Science\n",
                     "University of St Andrews\n",
                     "Jack Cole Building, North Haugh,\n",
                     "St Andrews, Fife, KY16 9SX, Scotland" ] ),
    Place         := "St Andrews",
    Institution   := "University of St Andrews"
     ),
  rec(
    LastName := "Soules",
    FirstNames := "Panagiotis",
    IsAuthor := true,
    IsMaintainer := false,
    Email := "psoules@math.uoa.gr",
    PostalAddress := Concatenation( [
                     "Panepistimioupolis\n",
                     "GR-15784, Athens, Greece" ] ),
    Place         := "Athens",
    Institution   := "National and Capodistrian University of Athens"              
     )
],

Status := "accepted",
CommunicatedBy := "Leonard Soicher (QMUL)",
AcceptDate := "01/2008",

README_URL := "http://www.cs.st-andrews.ac.uk/~alexk/circle/README.circle",
PackageInfoURL := "http://www.cs.st-andrews.ac.uk/~alexk/circle/PackageInfo.g",
AbstractHTML := "The <span class=\"pkgname\">Circle</span> package provides functionality for computations in adjoint groups of finite associative rings. It allows to construct circle objects that will respect the circle multiplication r*s=r+s+rs, create multiplicative groups, generated by such objects, and compute groups of elements, invertible with respect to this operation",
PackageWWWHome := "http://www.cs.st-andrews.ac.uk/~alexk/circle.htm",
                  
PackageDoc := rec(
  BookName := "Circle",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile := "doc/manual.pdf",
  SixFile := "doc/manual.six",
  LongTitle := "Adjoint groups of finite rings",
  Autoload := true
),

Dependencies := rec(
  GAP := ">=4.4",
  NeededOtherPackages := [ ["GAPDoc", ">= 1.1"] ],
  SuggestedOtherPackages := [],
  ExternalConditions := []
),

AvailabilityTest := ReturnTrue,
Autoload := false,
#TestFile := "tst/testall.g",

Keywords := ["circle multiplication", "star multiplication", 
             "adjoint semigroup", "adjoint group", "radical algebra"]
));