##############################################################################
##
#W  0805.g                      GAP4 package `Gpd'               Chris Wensley
##
#H  @(#)Id: "gpd/examples/0805.g", v.1.05 2008/11/21 
##
#Y  Copyright (C) 2008, Chris Wensley and Emma Moore,  
#Y  School of Computer Science, Bangor University, U.K. 

SetInfoLevel( InfoGpd, 1 );

TraceImmediateMethods( false );

Print( "\n===============================================================\n");
Print( "<<<< testing examples in the Gpd manual (version 21/11/08) >>>>\n" );
Print( "<<<<      functions for groupoids and their morphisms      >>>>\n" );
Print( "===============================================================\n\n");

######################################################## 

Print( "Some permutation groupoids:-\n" ); 
s4 := Group( (1,2,3,4), (3,4) ); 
SetName( s4, "s4" ); 
Gs4 := SinglePieceGroupoid( s4, [-9..-5] );
Print( "Gs4 = ", Gs4, "\n" );
SetName( Gs4, "Gs4" ); 

a4 := Subgroup( s4, [(1,2,3),(2,3,4)] ); 
SetName( a4, "a4" ); 
Fs4a := FullSubgroupoid( Gs4, [-9,-7,-5] );
Print( "Fs4a = ", Fs4a, "\n" );
SetName( Fs4a, "Fs4a" ); 
Ga4 := SubgroupoidByPieces( Fs4a, [ [ a4, [-9,-7,-5] ] ] );
Print( "Ga4 = ", Ga4, "\n" ); 
SetName( Ga4, "Ga4" ); 

d8 := Subgroup( s4, [(1,2,3,4), (1,3)] );;
SetName( d8, "d8" ); 
Fs4d := FullSubgroupoid( Gs4, [-8,-6] ); 
Print( "Fs4d = ", Fs4d, "\n" );
SetName( Fs4d, "Fs4d" ); 
Gd8 := SinglePieceGroupoidWithRays( Fs4d, d8, [(),(1,4)] );
Print( "Gd8 = ", Gd8, "\n" );
SetName( Gd8, "Gd8" ); 

id := IdentityMapping(a4); 
Print( "\nid map on a4 : ", id, "\n\n" ); 
m1 := GroupoidHomomorphismByObjectImages( Ga4, Ga4, [-7,-5,-9] ); 
Print( "mapping m1 = \n" ); 
Display( m1 ); 

gensa4 := GeneratorsOfGroup( a4 ); 
h2 := GroupHomomorphismByImages( a4, a4, gensa4, [(2,3,4), (1,3,4)] ); 
m2 := GroupoidHomomorphismByGroupHom( Ga4, Ga4, h2 ); 
Print( "mapping m2 = \n" ); 
Display( m2 ); 

prod3 := [(), (1,3)(2,4), (1,4)(2,3)]; 
m3 := GroupoidHomomorphismByRayProds( Ga4, Ga4, prod3 ); 
Print( "mapping m3 = \n" ); 
Display( m3 ); 

x := GroupoidElement( Ga4, (1,2)(3,4), -5, -7 ); 
Print( "\nx = ", x, "\n" ); 
x1 := ImageElm( m1, x ); 
Print( "x1 = ", x1, "\n" ); 
x2 := ImageElm( m2, x ); 
Print( "x2 = ", x2, "\n" ); 
x3 := ImageElm( m3, x ); 
Print( "x3 = ", x3, "\n" ); 

Print( "\nImage of Homset(Ga4,-5,-7) under m3 :-\n" ); 
for y in Homset( Ga4, -5, -7) do 
    y3 := ImageElm( m3, y ); 
    Print( "y = ", y, ",  y3 = ", y3, "\n" ); 
od; 

Print( "\nm12 := m1*m2  and  m123 := m12*m3 :-\n" ); 
m12 := m1*m2; 
Display( m12 ); 
m123 := m12*m3; 
Display( m123); 

Print( "\nImage of Homset(Ga4,-5,-7) under m12 :-\n" ); 
for y in Homset( Ga4, -5, -7) do 
    y3 := ImageElm( m12, y ); 
    Print( "y = ", y, ",  y3 = ", y3, "\n" ); 
od; 

Print( "\nImage of Homset(Ga4,-5,-7) under m123 :-\n" ); 
for y in Homset( Ga4, -5, -7) do 
    y3 := ImageElm( m123, y ); 
    Print( "y = ", y, ",  y3 = ", y3, "\n" ); 
od; 
Print( "\n" ); 
