############################################################################# 
## 
#W  mwohom.g                  GAP4 package `Gpd'                Chris Wensley 
##
#H  @(#)Id: "gpd/examples/mwohom.g" , v.1.05 2008/10/21 
##
#Y  Copyright (C) 2008, Chris Wensley,  
#Y  School of Computer Science, Bangor University, U.K. 
#Y

SetInfoLevel( InfoGpd, 1 );
##  TraceImmediateMethods( true );


Print( "\n===============================================================\n");
Print( "<<<< testing examples in the Gpd manual (version 21/11/08) >>>>\n" );
Print( "<<<< functions for magmas with objects and their morphisms >>>>\n" );
Print( "===============================================================\n\n");
    
Print("\n========================  MAGMA MAPPINGS  ===================\n\n");

Print( "three ways to set up an endomorphism on m :- \n\n" ); 

tup1 := [ Tuple([m1,m2]), Tuple([m2,m1]), Tuple([m3,m4]), Tuple([m4,m3]) ]; 
f1 := GeneralMappingByElements( m, m, tup1 ); 
Print( "f1 = ", f1, "\n" ); 
IsMagmaHomomorphism( f1 ); 
Print( "KnownPropertiesOfObject( f1 ) :-\n", 
    KnownPropertiesOfObject( f1 ), "\n\n" );

f1a := MappingByFunction( m, m, 
        function(x) 
           if ( x = MagmaElement(m,1)) then return MagmaElement(m,2); 
         elif ( x = MagmaElement(m,2)) then return MagmaElement(m,1); 
         elif ( x = MagmaElement(m,3)) then return MagmaElement(m,4); 
         elif ( x = MagmaElement(m,4)) then return MagmaElement(m,3);
           fi; 
        end ); 
Print( "f1a = ", f1a, "\n" ); 
IsMagmaHomomorphism( f1a ); 
Print( "KnownPropertiesOfObject( f1a ) :-\n", 
    KnownPropertiesOfObject( f1a ), "\n\n" );

Print( "f1 = f1a ? ", f1=f1a, "\n\n" ); 

tup2 := [ Tuple([m1,m1]), Tuple([m2,m1]), Tuple([m3,m1]), Tuple([m4,m1]) ]; 
f2 := GeneralMappingByElements( m, m, tup2 ); 
Print( "f2 = ", f2, "\n" ); 
IsMagmaHomomorphism( f2 ); 
Print( "KnownPropertiesOfObject( f2 ) :-\n", 
    KnownPropertiesOfObject( f2 ), "\n\n" );

########################################################################

Print( "now use f1/f1a/f2 to make endomorphisms of M78 :- \n\n" ); 

map1 := MagmaWithObjectsHomomorphism( M78, M78, f1, [-8,-7] ); 
idm := f1*f1; 
idmap := MagmaWithObjectsHomomorphism( M78, M78, idm, [-7,-8] ); 
Print( "map1 = ", map1, "\nidmap = ", idmap, "\n" ); 
map1a := MagmaWithObjectsHomomorphism( M78, M78, f1a, [-8,-7] ); 
Print( "map1a = ", map1a, "\n" ); 
map2 := MagmaWithObjectsHomomorphism( M78, M78, f2, [-7,-8] ); 
Print( "map2 = ", map2, "\n" ); 

########################################################################

Print( "\nforming groups etc.\n\n" ); 

G1 := Group( f1 );
Print( "G1 = ", G1, "  has size ", Size(G1), "\n" ); 
Print( "One(G1) = ", One(G1), "\n\n" ); 

##ok := IsEndoGeneralMapping( map1 ); 
##Print( "ok = ", ok, "\n" ); 
##ok := IsGeneralMappingCollection( [map1] ); 
##Print( "ok = ", ok, "\n" ); 

map1b := map1*idmap; 
Print( "map1b = ", map1b, "\n" ); 

map1a3 := map1a*map2; 
Print( "map1a3 = ", map1a3, "\n" ); 
map22 := map2*map1a;
Print( "map22 = ", map22, "\n" ); 
Print( "map1a3 = map22 ? ", map1a3=map22, "\n" ); 

