##############################################################################
##
#W  mwo.tst                       Gpd Package                    Chris Wensley
##
#H  @(#)$Id: mwo.tst,v 1.05 2008/11/21 gap Exp $
##
#Y  Copyright (C) 1999,2001 University of St. Andrews, North Haugh,
#Y                          St. Andrews, Fife KY16 9SS, Scotland
##

gap> START_TEST( "Testing examples in Chapter 2 of the Gpd manual" );

gap> gpd_infolevel_saved := InfoLevel( InfoGpd );; 
gap> SetInfoLevel( InfoGpd, 0 );; 

gap> tm := [[1,2,4,3],[1,2,4,3],[3,4,2,1],[3,4,2,1]];;  Display( tm );
[ [  1,  2,  4,  3 ],
  [  1,  2,  4,  3 ],
  [  3,  4,  2,  1 ],
  [  3,  4,  2,  1 ] ]
gap> m := MagmaByMultiplicationTable( tm ); 
<magma with 4 generators>
gap> SetName( m, "m" ); 
gap> m1 := MagmaElement(m,1);; 
gap> m2 := MagmaElement(m,2);; 
gap> m3 := MagmaElement(m,3);; 
gap> m4 := MagmaElement(m,4);; 
gap> One(m); 
fail
gap> M78 := MagmaWithObjects( m, [-8,-7] ); 
magma with objects :-
    magma = m
  objects = [ -8, -7 ]

gap> [ IsAssociative(M78), IsCommutative(M78) ]; 
[ false, false ]

gap> a78 := MultiplicativeElementWithObjects( M78, m2, -7, -8 ); 
[m2 : -7 -> -8]
gap> b87 := MultiplicativeElementWithObjects( M78, m3, -8, -7 ); 
[m3 : -8 -> -7]
gap> ba := b87*a78; 
[m4 : -8 -> -8]
gap> ab := a78*b87;
[m4 : -7 -> -7]
gap> a78^2; 
fail
gap> ba^2;
[m1 : -8 -> -8]

gap> IsSinglePiece( M78 ); 
true
gap> IsDirectProductWithCompleteGraph( M78 );
true


gap> SetInfoLevel( InfoGpd, gpd_infolevel_saved );;  

gap> STOP_TEST( "mwo.tst", 10000 );

#############################################################################
##
#E  mwo.tst . . . . . . . . . . . . . . . . . . . . . . . . . . . . ends here
